<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>FourLetterWordMain.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.client</a> &gt; <span class="el_source">FourLetterWordMain.java</span></div><h1>FourLetterWordMain.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.client;

import org.apache.log4j.Logger;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketTimeoutException;

<span class="nc" id="L32">public class FourLetterWordMain {</span>
    //in milliseconds, socket should connect/read within this period otherwise SocketTimeoutException
    private static final int DEFAULT_SOCKET_TIMEOUT = 5000;
<span class="fc" id="L35">    protected static final Logger LOG = Logger.getLogger(FourLetterWordMain.class);</span>
    
    /**
     * Send the 4letterword
     * @param host the destination host
     * @param port the destination port
     * @param cmd the 4letterword
     * @return server response
     * @throws java.io.IOException
     */
    public static String send4LetterWord(String host, int port, String cmd)
            throws IOException
    {
<span class="fc" id="L48">        return send4LetterWord(host, port, cmd, DEFAULT_SOCKET_TIMEOUT);</span>
    }
    /**
     * Send the 4letterword
     * @param host the destination host
     * @param port the destination port
     * @param cmd the 4letterword
     * @param timeout in milliseconds, maximum time to wait while connecting/reading data
     * @return server response
     * @throws java.io.IOException
     */
    public static String send4LetterWord(String host, int port, String cmd, int timeout)
            throws IOException
    {
<span class="fc" id="L62">        LOG.info(&quot;connecting to &quot; + host + &quot; &quot; + port);</span>
<span class="fc" id="L63">        Socket sock = new Socket();</span>
<span class="pc bpc" id="L64" title="1 of 2 branches missed.">        InetSocketAddress hostaddress= host != null ? new InetSocketAddress(host, port) :</span>
<span class="pc" id="L65">            new InetSocketAddress(InetAddress.getByName(null), port);</span>
<span class="fc" id="L66">        BufferedReader reader = null;</span>
        try {
<span class="fc" id="L68">            sock.setSoTimeout(timeout);</span>
<span class="fc" id="L69">            sock.connect(hostaddress, timeout);</span>
<span class="fc" id="L70">            OutputStream outstream = sock.getOutputStream();</span>
<span class="fc" id="L71">            outstream.write(cmd.getBytes());</span>
<span class="fc" id="L72">            outstream.flush();</span>
            // this replicates NC - close the output stream before reading
<span class="fc" id="L74">            sock.shutdownOutput();</span>

<span class="fc" id="L76">            reader =</span>
                    new BufferedReader(
<span class="fc" id="L78">                            new InputStreamReader(sock.getInputStream()));</span>
<span class="fc" id="L79">            StringBuilder sb = new StringBuilder();</span>
            String line;
<span class="fc bfc" id="L81" title="All 2 branches covered.">            while((line = reader.readLine()) != null) {</span>
<span class="fc" id="L82">                sb.append(line + &quot;\n&quot;);</span>
            }
<span class="fc" id="L84">            return sb.toString();</span>
<span class="nc" id="L85">        } catch (SocketTimeoutException e) {</span>
<span class="nc" id="L86">            throw new IOException(&quot;Exception while executing four letter word: &quot; + cmd, e);</span>
        } finally {
<span class="fc" id="L88">            sock.close();</span>
<span class="pc bpc" id="L89" title="2 of 4 branches missed.">            if (reader != null) {</span>
<span class="pc" id="L90">                reader.close();</span>
            }
        }
    }
    
    public static void main(String[] args)
            throws IOException
    {
<span class="nc bnc" id="L98" title="All 2 branches missed.">        if (args.length != 3) {</span>
<span class="nc" id="L99">            System.out.println(&quot;Usage: FourLetterWordMain &lt;host&gt; &lt;port&gt; &lt;cmd&gt;&quot;);</span>
        } else {
<span class="nc" id="L101">            System.out.println(send4LetterWord(args[0], Integer.parseInt(args[1]), args[2]));</span>
        }
<span class="nc" id="L103">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>